package samples.user;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.AbstractTransactionalJUnit4SpringContextTests;

import com.ibatis.sqlmap.client.SqlMapClient;

@ContextConfiguration(
	locations={"classpath:applicationContext.xml", "classpath:applicationContext-sqlmap.xml"})
public class UserDaoWithSqlMapTest extends AbstractTransactionalJUnit4SpringContextTests {
	@Autowired
	protected SqlMapClient sqlMapClient;
	
	private SqlMapUserDao userDao;
	
	@Before public void setup() {
		deleteFromTables("USER");
		
		userDao = new SqlMapUserDao();
		userDao.setSqlMapClient(sqlMapClient);
	}
	
	@Test public void insert() {
		User user = createUser();
		userDao.insert(user);
		
		assertEquals(1, countRowsInTable("USER"));
	}
	
	@Test public void findUser() {
		User user = createUser();
		userDao.insert(user);

		User result1 = userDao.findUser(user.getUserId());
		assertEquals(user, result1);
	}
	
	private User createUser() {
		User user = new User();
		user.setUserId("testuser22");
		user.setPassword("password");
		user.setName("jaesung");
		user.setEmail("javajigi@gmail.com");
		user.setRoleType(RoleType.ADMIN);

		return user;
	}
}
